﻿{*******************************************************}
{                                                       }
{  Files: windows.data.pdf.h                            }
{    Copyright (C) Microsoft Corporation.               }
{    All Rights Reserved.                               }
{                                                       }
{  Translator: Lyna                                     }
{    Copyright(c) 2016 Lyna  All rights reserved.       }
{                                                       }
{*******************************************************}
unit Winapi.Data.Pdf;

{$ALIGN ON}
{$MINENUMSIZE 4}
{$SCOPEDENUMS ON}

interface

uses
  System.Win.WinRT, Winapi.Windows, Winapi.Winrt, Winapi.Foundation, Winapi.Foundation.Types,
  Winapi.Storage, Winapi.Storage.Streams;

type
  // from Windows.Foundation
  __x_ABI_CWindows_CFoundation_CSize = record
    Width: Single;
    Height: Single;
  end;
  
  // from Windows.Foundation
  __x_ABI_CWindows_CFoundation_CRect = record
    X: Single;
    Y: Single;
    Width: Single;
    Height: Single;
  end;

  // from Windows.UI
  __x_ABI_CWindows_CUI_CColor = record
    A: BYTE;
    R: BYTE;
    G: BYTE;
    B: BYTE;
  end;

const
  RuntimeClass_Windows_Data_Pdf_PdfPageRenderOptions = 'Windows.Data.Pdf.PdfPageRenderOptions';
  RuntimeClass_Windows_Data_Pdf_PdfPageDimensions = 'Windows.Data.Pdf.PdfPageDimensions';
  RuntimeClass_Windows_Data_Pdf_PdfPage = 'Windows.Data.Pdf.PdfPage';
  RuntimeClass_Windows_Data_Pdf_PdfDocument = 'Windows.Data.Pdf.PdfDocument';

type
  IAsyncOperation_1_Windows__CData__CPdf__CPdfDocument = interface;

//  IAsyncOperationCompletedHandler_1_Windows__CData__CPdf__CPdfDocument = interface(IUnknown)
//    ['{8d4950b3-629d-5d7d-84cc-04c0dcf7942b}']
//    procedure Invoke(
//      asyncInfo: IAsyncOperation_1_Windows__CData__CPdf__CPdfDocument;
//      status: AsyncStatus); safecall;
//  end;
//
//  IAsyncOperation_1_Windows__CData__CPdf__CPdfDocument = interface(IInspectable)
//    ['{d6b166ec-099a-5ee2-ad2e-f4c88614aabb}']
//    procedure put_Completed(
//      handler: IAsyncOperationCompletedHandler_1_Windows__CData__CPdf__CPdfDocument); safecall;
//    function get_Completed: IAsyncOperationCompletedHandler_1_Windows__CData__CPdf__CPdfDocument; safecall;
//    function GetResults: IPdfDocument; safecall;
//    property Completed: IAsyncOperationCompletedHandler_1_Windows__CData__CPdf__CPdfDocument read get_Completed write put_Completed;
//  end;

  IAsyncOperation<T: IInspectable> = interface;

  IAsyncOperationCompletedHandler<T: IInspectable> = interface(IUnknown)
    ['{5233899b-ba7e-504f-bb83-ceebac62decf}']
    procedure Invoke(asyncInfo: IAsyncOperation<T>; status: AsyncStatus); safecall;
  end;

  IAsyncOperation<T: IInspectable> = interface(IInspectable)
    ['{6607bc41-294b-5975-9c3f-4b49836d0916}']
    procedure put_Completed(handler: IAsyncOperationCompletedHandler<T>); safecall;
    function get_Completed: IAsyncOperationCompletedHandler<T>; safecall;
    function GetResults: T; safecall;
    property Completed: IAsyncOperationCompletedHandler<T> read get_Completed write put_Completed;
  end;

  // Windows.Data.Pdf.PdfPageRotation
  PdfPageRotation = (
    Normal	= 0,
    Rotate90	= 1,
    Rotate180	= 2,
    Rotate270	= 3
  );

  // Windows.Data.Pdf.IPdfPageDimensions
  [WinRTClassNameAttribute(RuntimeClass_Windows_Data_Pdf_PdfPageDimensions)]
  IPdfPageDimensions = interface(IInspectable)
    ['{22170471-313E-44E8-835D-63A3E7624A10}']
    function get_MediaBox: __x_ABI_CWindows_CFoundation_CRect; safecall;
    function get_CropBox: __x_ABI_CWindows_CFoundation_CRect; safecall;
    function get_BleedBox: __x_ABI_CWindows_CFoundation_CRect; safecall;
    function get_TrimBox: __x_ABI_CWindows_CFoundation_CRect; safecall;
    function get_ArtBox: __x_ABI_CWindows_CFoundation_CRect; safecall;
    property MediaBox: __x_ABI_CWindows_CFoundation_CRect read get_MediaBox;
    property CropBox: __x_ABI_CWindows_CFoundation_CRect read get_CropBox;
    property BleedBox: __x_ABI_CWindows_CFoundation_CRect read get_BleedBox;
    property TrimBox: __x_ABI_CWindows_CFoundation_CRect read get_TrimBox;
    property ArtBox: __x_ABI_CWindows_CFoundation_CRect read get_ArtBox;
  end;

  // Windows.Data.Pdf.IPdfPageRenderOptions
  [WinRTClassNameAttribute(RuntimeClass_Windows_Data_Pdf_PdfPageRenderOptions)]
  IPdfPageRenderOptions = interface(IInspectable)
    ['{3C98056F-B7CF-4C29-9A04-52D90267F425}']
    function get_SourceRect: __x_ABI_CWindows_CFoundation_CRect; safecall;
    procedure put_SourceRect(value: __x_ABI_CWindows_CFoundation_CRect); safecall;
    function get_DestinationWidth: UINT32; safecall;
    procedure put_DestinationWidth(value: UINT32); safecall;
    function get_DestinationHeight: UINT32; safecall;
    procedure put_DestinationHeight(value: UINT32); safecall;
    function get_BackgroundColor: __x_ABI_CWindows_CUI_CColor; safecall;
    procedure put_BackgroundColor(value: __x_ABI_CWindows_CUI_CColor); safecall;
    function get_IsIgnoringHighContrast: Boolean; safecall;
    procedure put_IsIgnoringHighContrast(value: Boolean); safecall;
    function get_BitmapEncoderId: TGUID; safecall;
    procedure put_BitmapEncoderId(value: TGUID); safecall;
    property SourceRect: __x_ABI_CWindows_CFoundation_CRect read get_SourceRect write put_SourceRect;
    property DestinationWidth: UINT32 read get_DestinationWidth write put_DestinationWidth;
    property DestinationHeight: UINT32 read get_DestinationHeight write put_DestinationHeight;
    property BackgroundColor: __x_ABI_CWindows_CUI_CColor read get_BackgroundColor write put_BackgroundColor;
    property IsIgnoringHighContrast: Boolean read get_IsIgnoringHighContrast write put_IsIgnoringHighContrast;
    property BitmapEncoderId: TGUID read get_BitmapEncoderId write put_BitmapEncoderId;
  end;

  // Windows.Data.Pdf.IPdfPage
  [WinRTClassNameAttribute(RuntimeClass_Windows_Data_Pdf_PdfPage)]
  IPdfPage = interface(IInspectable)
    ['{9DB4B0C8-5320-4CFC-AD76-493FDAD0E594}']
    function RenderToStreamAsync(
      outputStream: IRandomAccessStream): IAsyncAction; safecall;
    function RenderWithOptionsToStreamAsync(
      outputStream: IRandomAccessStream;
      options: IPdfPageRenderOptions): IAsyncAction; safecall;
    function PreparePageAsync: IAsyncAction; safecall;
    function get_Index: UINT32; safecall;
    function get_Size: __x_ABI_CWindows_CFoundation_CSize; safecall;
    function get_Dimensions: IPdfPageDimensions; safecall;
    function get_Rotation: PdfPageRotation; safecall;
    function get_PreferredZoom: Single; safecall;
    property Index: UINT32 read get_Index;
    property Size: __x_ABI_CWindows_CFoundation_CSize read get_Size;
    property Dimensions: IPdfPageDimensions read get_Dimensions;
    property Rotation: PdfPageRotation read get_Rotation;
    property PreferredZoom: Single read get_PreferredZoom;
  end;

  // Windows.Data.Pdf.IPdfDocument
  [WinRTClassNameAttribute(RuntimeClass_Windows_Data_Pdf_PdfDocument)]
  IPdfDocument = interface(IInspectable)
    ['{AC7EBEDD-80FA-4089-846E-81B77FF5A86C}']
    function GetPage(pageIndex: UINT32): IPdfPage; safecall;
    function get_PageCount: UINT32; safecall;
    function get_IsPasswordProtected: Boolean; safecall;
    property PageCount: UINT32 read get_PageCount;
    property IsPasswordProtected: Boolean read get_IsPasswordProtected;
  end;

  // Windows.Data.Pdf.IPdfDocumentStatics
  [WinRTClassNameAttribute(RuntimeClass_Windows_Data_Pdf_PdfDocument)]
  IPdfDocumentStatics = interface(IInspectable)
    ['{433A0B5F-C007-4788-90F2-08143D922599}']
    function LoadFromFileAsync(
      file_: IStorageFile): IAsyncOperation<IPdfDocument>; safecall;
    function LoadFromFileWithPasswordAsync(
      file_: IStorageFile;
      password: HSTRING): IAsyncOperation<IPdfDocument>; safecall;
    function LoadFromStreamAsync(
      inputStream: IRandomAccessStream): IAsyncOperation<IPdfDocument>; safecall;
    function LoadFromStreamWithPasswordAsync(
      inputStream: IRandomAccessStream;
      password: HSTRING): IAsyncOperation<IPdfDocument>; safecall;
  end;

  IAsyncOperationCompletedHandler_1_Windows__CData__CPdf__CPdfDocument = interface(IAsyncOperationCompletedHandler<IPdfDocument>)
    ['{8d4950b3-629d-5d7d-84cc-04c0dcf7942b}']
  end;

  IAsyncOperation_1_Windows__CData__CPdf__CPdfDocument = interface(IAsyncOperation<IPdfDocument>)
    ['{d6b166ec-099a-5ee2-ad2e-f4c88614aabb}']
  end;

implementation

end.